unsigned int address  = 0;    // I2C address
unsigned int data = 0;   // I2C data
unsigned int inByte = 0;         // incoming serial byte
unsigned int inChar = 0;
unsigned int camera = 0;
String inString = "";    // string to hold input
String inStringTrimed ="" ; //trimed string
String cmdarg1 = "" ;
String cmdarg2 = "" ;
String arg1 = "" ;
String arg2 = "" ;
int arglen1 =0;
int arglen2 =0;
char argbyte1[10];
char argbyte2[10];
char *endptr;
#include <Wire.h>
byte x = 0;

void setup()
{
  // start serial port at 9600 bps:
  Serial.begin(9600);
  // join i2c bus (address optional for master)
  Wire.begin();
   PrintMenu()  ;
   SelectCamera();
       Serial.print("Camera : ");
       Serial.println(camera,DEC);
    if (Serial.available() > 0) {
      inChar = Serial.read();
    }
    dataclr();
}

void loop()
{   
  input();
  inString.trim();
  inStringTrimed = inString;
  if(inStringTrimed[0] == 'w' | inStringTrimed[0] == 'W')
  {
    inStringTrimed[0] = ' ';
    inStringTrimed.trim();
    cmdarg1 = inStringTrimed;
    arglen1 = cmdarg1.indexOf(' ');
    arg1 = cmdarg1.substring(0,arglen1); 
    for (int i=0; i < arglen1; i++){
      cmdarg1[i] = ' '; 
    }
    cmdarg1.trim();
    cmdarg2 = cmdarg1;
    arglen2 = cmdarg2.indexOf(' ');
    if (arglen2 == -1 )
    {
      arglen2 = cmdarg2.length();
      arg2 = cmdarg2; 
    }
    else
    {
      arg2 = cmdarg2.substring(0,arglen2);  
    }
    arg1.toCharArray(argbyte1,arglen1+1);
    arg2.toCharArray(argbyte2,arglen2+1);
    address =  hexsz2int(argbyte1);
    data    =  hexsz2int(argbyte2);
    printdata(address,data);
    write_data(camera,address,data);
    delay(5);
  }
  else if (inStringTrimed[0] == 'r' | inStringTrimed[0] == 'R')
  {
    inStringTrimed[0] = ' ';
    inStringTrimed.trim();
    cmdarg1 = inStringTrimed;
    arglen1 = 4;
    arg1 = cmdarg1.substring(0,4);
    arg1.toCharArray(argbyte1, arglen1+1);
    address =  hexsz2int(argbyte1);
    data =  read_data(camera,address);
    printdata(address,data);
    delay(5);
  }
  else if (inStringTrimed[0] == 'h' | inStringTrimed[0] == 'H')
  {
   help();
  }
  else
  {
    Serial.println("Syntax Error");
  }
 dataclr();
}

void dataclr()
{
  inString = ""; 
  inChar = 0;
  inStringTrimed ="" ; //trimed string
  cmdarg1 = "" ;
  cmdarg2 = "" ;
  arg1 = "" ;
  arg2 = "" ;
  arglen1 =0;
  arglen2 =0;
  data = 0;
}


void write_data(unsigned int cam, unsigned int regID, unsigned int regDat)
    {     
      byte dat;
      switch(cam)
      {
      case 1:  //OV7670,7690
          Wire.beginTransmission(0x21); // write 0x42 read 0x43
          Wire.write(regID);        // sends address
          Wire.write(regDat);              // sends data  
          Wire.endTransmission();    // stop transmitting
          delay(1);
      break;
      case 2:  //OV5642
        Wire.beginTransmission(0x3C); // write 0x78 read 0x79
	delay(1);
        dat = regID>>8 ;
        Wire.write(dat);
	delay(1);
        dat = regID   ;
        Wire.write(dat);
	delay(1);
        Wire.write(regDat);
        delay(1);
        Wire.endTransmission();    // stop transmitting
      break;

      case 3:  //MT9V111
        Wire.beginTransmission(0x48); // write 0x90 read 0x91
	delay(1);
        dat = regID      ;
        Wire.write(dat);
	delay(1);
        dat = regDat>>8   ;
        Wire.write(dat);
	delay(1);
        dat = regDat      ;
        Wire.write(regDat);
        delay(1);
        Wire.endTransmission();    // stop transmitting
      break;
      }
   }
     
unsigned int read_data(unsigned int cam, unsigned int regID)
{
      unsigned int readdata , dat1 , dat2;
      byte dat;  
      switch(cam)
      {
      case 1:  //OV7670,7690
         Wire.beginTransmission(0x21); // write 0x42 read 0x43
         Wire.write(regID);        // sends address
         Wire.endTransmission();    // stop transmitting 
         Wire.requestFrom(0x21, 1);
         dat = Wire.read();
         readdata = dat;
      break;
      case 2:  //OV5642
        Wire.beginTransmission(0x3C); // write 0x78 read 0x79
	delay(1);
        dat = regID>>8 ;
        Wire.write(dat);
	delay(1);
        dat = regID   ;
        Wire.write(dat);
	delay(1);
        Wire.endTransmission();    // stop transmitting
	delay(1);
        Wire.beginTransmission(0x3C); // write 0x78 read 0x79
	delay(1);
        Wire.requestFrom(0x3C, 1);
	delay(1);
        dat = Wire.read();
	delay(1);
        Wire.endTransmission();    // stop transmitting
         readdata = dat;       
      break;
      case 3:  //MT9V111
       Wire.beginTransmission(0x48); // write 0x90 read 0x91
	delay(1);
        dat = regID   ;
        Wire.write(dat);
	delay(1);
        Wire.endTransmission();    // stop transmitting
	delay(1);
        Wire.beginTransmission(0x48); // write 0x90 read 0x91
        delay(1);
        Wire.requestFrom(0x48, 2);
	delay(1);
        dat1 = Wire.read();
	delay(1);
        dat2 = Wire.read();
        readdata = dat1<<8 | dat2 ;
        Wire.endTransmission();    // stop transmitting   
      break;
      }
        return readdata;
}
void printdata(unsigned int add,unsigned int dat)
{
    Serial.print("Ad=");
    Serial.print(add,HEX);

    Serial.print("  Dt(H)=");
    Serial.print(dat,HEX);
    Serial.print("  Dt(D)=");  
    Serial.println(dat,DEC);
}

void PrintMenu(void)
{
  Serial.println("------------------------------");
  Serial.println(" Universal Camera Debugger");
  Serial.println(" Copyright 2014 Hirokazu Enya");
  Serial.println("------------------------------");
}

void SelectCamera(void)
{
  unsigned int cam;
  Serial.println("");
  Serial.println(" Select Camera");
  Serial.println("");
  Serial.println(" 1 : OV7670/7690");
  Serial.println(" 2 : OV5642");
  Serial.println(" 3 : MT9V111");
  Serial.println("------------------------------");
  Serial.println("");
  Serial.print("Sel?");
  input();
  inString.trim();
  inString.toCharArray(argbyte1,2);
  camera = hexsz2int(argbyte1);
}

void help()
{
    Serial.println("WRITE :w [address] [data]");
    Serial.println("READ  :r [address] ");
    Serial.println("HELP :h ");
}

void input()
{    
  //Command input
    inChar == 0 ;
  Serial.print(">");
  while (inChar != 13 ) {
    if (Serial.available() > 0) {
      inChar = Serial.read();
      Serial.print((char)inChar);
      inString += (char)inChar; 
    }  
  }  
    Serial.println("");
}


//"hexsz2int" is part of fuction "maybekanji"
//original source from below URL
//<http://www.koders.com/cpp/fid2BB5F1A942B42648647CBD66ED9A2A03B1C00B5F.aspx>

/*
 * The following function "maybekanji" is derived from
 * RJIS-1.0 by Mr. Hironobu Takahashi.
 * Maybekanji() is included here under the courtesy of the author.
 * The original comment of rjis.c is also included here.
 */

/*
 * RJIS ( Recover JIS code from broken file )
 * Copyright (C) 1992 1994
 * Hironobu Takahashi (takahasi@tiny.or.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either versions 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SKK, see the file COPYING.  If not, write to the Free
 * Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

int hexsz2int(char *str)
{
  int val;
  int sign;

  while (*str == ' ' || *str == '\t') str++;
  sign = 1;
  if (*str == '+') str++;
  else if (*str == '-') {
    sign = -1;
    str++;
  }
  val = 0;
  while (*str >= '0' && *str <= '9' ||
    *str >= 'A' && *str <= 'F' ||
    *str >= 'a' && *str <= 'f') {
    val <<= 4;
    if      (*str >= '0' && *str <= '9') val += *str - '0';
    else if (*str >= 'A' && *str <= 'F') val += *str - 'A' + 10;
    else                                 val += *str - 'a' + 10;
    str++;
  }

  return sign == 1 ? val : -val;
}






